
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Infrastructure_clustersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const infrastructure_clusters = await db.infrastructure_clusters.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        cluster_type: data.cluster_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        region: data.region
        ||
        null
            ,
            
        provider: data.provider
        ||
        null
            ,
            
        api_gateway_url: data.api_gateway_url
        ||
        null
            ,
            
        cpu_capacity: data.cpu_capacity
        ||
        null
            ,
            
        gpu_capacity: data.gpu_capacity
        ||
        null
            ,
            
        storage_capacity_tb: data.storage_capacity_tb
        ||
        null
            ,
            
        last_audit_at: data.last_audit_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await infrastructure_clusters.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return infrastructure_clusters;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const infrastructure_clustersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                cluster_type: item.cluster_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                region: item.region
            ||
            null
            ,
            
                provider: item.provider
            ||
            null
            ,
            
                api_gateway_url: item.api_gateway_url
            ||
            null
            ,
            
                cpu_capacity: item.cpu_capacity
            ||
            null
            ,
            
                gpu_capacity: item.gpu_capacity
            ||
            null
            ,
            
                storage_capacity_tb: item.storage_capacity_tb
            ||
            null
            ,
            
                last_audit_at: item.last_audit_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const infrastructure_clusters = await db.infrastructure_clusters.bulkCreate(infrastructure_clustersData, { transaction });

        // For each item created, replace relation files
        

        return infrastructure_clusters;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const infrastructure_clusters = await db.infrastructure_clusters.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.cluster_type !== undefined) updatePayload.cluster_type = data.cluster_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.region !== undefined) updatePayload.region = data.region;
        
        
        if (data.provider !== undefined) updatePayload.provider = data.provider;
        
        
        if (data.api_gateway_url !== undefined) updatePayload.api_gateway_url = data.api_gateway_url;
        
        
        if (data.cpu_capacity !== undefined) updatePayload.cpu_capacity = data.cpu_capacity;
        
        
        if (data.gpu_capacity !== undefined) updatePayload.gpu_capacity = data.gpu_capacity;
        
        
        if (data.storage_capacity_tb !== undefined) updatePayload.storage_capacity_tb = data.storage_capacity_tb;
        
        
        if (data.last_audit_at !== undefined) updatePayload.last_audit_at = data.last_audit_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await infrastructure_clusters.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await infrastructure_clusters.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return infrastructure_clusters;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const infrastructure_clusters = await db.infrastructure_clusters.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of infrastructure_clusters) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of infrastructure_clusters) {
                await record.destroy({transaction});
            }
        });


        return infrastructure_clusters;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const infrastructure_clusters = await db.infrastructure_clusters.findByPk(id, options);

        await infrastructure_clusters.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await infrastructure_clusters.destroy({
            transaction
        });

        return infrastructure_clusters;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const infrastructure_clusters = await db.infrastructure_clusters.findOne(
            { where },
            { transaction },
        );

        if (!infrastructure_clusters) {
            return infrastructure_clusters;
        }

        const output = infrastructure_clusters.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.edge_sensors_cluster = await infrastructure_clusters.getEdge_sensors_cluster({
            transaction
        });
        
        
        
        
        
        output.organizations = await infrastructure_clusters.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'infrastructure_clusters',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'infrastructure_clusters',
                        'region',
                        filter.region,
                    ),
                };
            }
            
            if (filter.provider) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'infrastructure_clusters',
                        'provider',
                        filter.provider,
                    ),
                };
            }
            
            if (filter.api_gateway_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'infrastructure_clusters',
                        'api_gateway_url',
                        filter.api_gateway_url,
                    ),
                };
            }
            

            
            

            
            if (filter.cpu_capacityRange) {
                const [start, end] = filter.cpu_capacityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cpu_capacity: {
                    ...where.cpu_capacity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cpu_capacity: {
                    ...where.cpu_capacity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.gpu_capacityRange) {
                const [start, end] = filter.gpu_capacityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    gpu_capacity: {
                    ...where.gpu_capacity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    gpu_capacity: {
                    ...where.gpu_capacity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.storage_capacity_tbRange) {
                const [start, end] = filter.storage_capacity_tbRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    storage_capacity_tb: {
                    ...where.storage_capacity_tb,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    storage_capacity_tb: {
                    ...where.storage_capacity_tb,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_audit_atRange) {
                const [start, end] = filter.last_audit_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_audit_at: {
                    ...where.last_audit_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_audit_at: {
                    ...where.last_audit_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.cluster_type) {
                where = {
                    ...where,
                cluster_type: filter.cluster_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.infrastructure_clusters.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'infrastructure_clusters',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.infrastructure_clusters.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

